#!/usr/bin/bash

echo "

define basis_elements() {
    print \"a b e f\n\"
}

ignore = basis_elements()

" | bc -q |

awk '

{
    n = split($0, arg);

    printf ("define e_copy(o,i) {\n");
    for (i=1; i<=n; ++i)
        printf("  %s[o] = %s[i]\n", arg[i], arg[i]);
    printf ("}\n\n");

    printf ("define e_negate(o,i) {\n");
    for (i=1; i<=n; ++i)
        printf("  %s[o] = -%s[i]\n", arg[i], arg[i]);
    printf ("}\n\n");

    printf ("define e_add(o,i,j) {\n");
    for (i=1; i<=n; ++i)
        printf("  %s[o] = %s[i] + %s[j]\n", arg[i], arg[i], arg[i]);
    printf ("}\n\n");

    printf ("define e_subtract(o,i,j) {\n");
    for (i=1; i<=n; ++i)
        printf("  %s[o] = %s[i] - %s[j]\n", arg[i], arg[i], arg[i]);
    printf ("}\n\n");

    printf ("define be_scale(o,i) {\n");
    for (i=1; i<=n; ++i)
        printf("  %s[o] *= n[i]\n", arg[i]);
    printf ("}\n\n");

}

'