#!/bin/bash

a=1
b=1
c=1
d=1

prime=17

{
    cat poly.$prime.bc

    cat <<EOF
    a=$a
    b=$b
    c=$c
    d=$d

    x4coeff = coeff_x4(a,b,c,d)
    x3coeff = coeff_x3(a,b,c,d)
    x2coeff = coeff_x2(a,b,c,d)
    x1coeff = coeff_x1(a,b,c,d)
    x0coeff = coeff_x0(a,b,c,d)

    print " a = ", a
    print " b = ", b
    print " c = ", c
    print " d = ", d
    print "    "

    print x4coeff, "*x^4 + "
    print x3coeff, "*x^3 + "
    print x2coeff, "*x^2 + "
    print x1coeff, "*x^1 + "
    print x0coeff, "*x^0\n"

    halt
    limit = 200

    print "---------------------------\n"

    for (a=-limit; a<=limit; a += 4) {
        c = -a/4
        for (b=-limit; b<=limit; b += 1) {
            for (d=-limit; d<=limit; d += 1) {

                x3coeff = coeff_x3(a,b,c,d)

                if (x3coeff != 0) continue

                x4coeff = coeff_x4(a,b,c,d)
                x2coeff = coeff_x2(a,b,c,d)
                x1coeff = coeff_x1(a,b,c,d)
                x0coeff = coeff_x0(a,b,c,d)

                print " a = ", a
                print " b = ", b
                print " c = ", c
                print " d = ", d
                print "    "

                print x4coeff, "*x^4 + "
                print x3coeff, "*x^3 + "
                print x2coeff, "*x^2 + "
                print x1coeff, "*x^1 + "
                print x0coeff, "*x^0\n"
            }
        }
    }
EOF
} |

bc -q
