#!/bin/bash

s=10
t=2
u=1
v=1
 
# S + Tz
# ------
# U + Vz
 
S=10
T=11
U=12
V=13
 
a[S]=$s
b[S]=0
e[S]=0
f[S]=0
 
a[T]=$t
b[T]=0
e[T]=0
f[T]=0
 
a[U]=$u
b[U]=0
e[U]=0
f[U]=0
 
a[V]=$v
b[V]=0
e[V]=0
f[V]=0
 
function main
{
    parse_args $*
 
    multiply 20  1 $T
    add      21 20 $S
 
    multiply 30  1 $V
    add      31 30 $U
 
    conjugate 32 31
    conjugate 33 32
    conjugate 34 33
 
    multiply 40 32 33
    multiply 41 40 34
 
    multiply 42 41 21
 
    multiply 43 41 31
 
    echo "numerator:"
    display 42
 
    echo "denominator:"
    display 43
}

function copy
{
    typeset o=$1
    typeset i=$2
 
    a[o]=$(( a[i] ))
    b[o]=$(( b[i] ))
    e[o]=$(( e[i] ))
    f[o]=$(( f[i] ))
}
 
function negate
{
    typeset o=$1
    typeset i=$2
 
    a[o]=$(( -a[i] ))
    b[o]=$(( -b[i] ))
    e[o]=$(( -e[i] ))
    f[o]=$(( -f[i] ))
}
 
function add
{
    typeset o=$1
    typeset i=$2
    typeset j=$3
 
    a[o]=$(( a[i] + a[j] ))
    b[o]=$(( b[i] + b[j] ))
    e[o]=$(( e[i] + e[j] ))
    f[o]=$(( f[i] + f[j] ))
}
 
function multiply
{
    typeset o=$1
    typeset i=$2
    typeset j=$3
 
    a[o]=$(( a[i]*a[j] - 4*b[i]*f[j] - 2*e[i]*e[j] - 4*f[i]*b[j] - 16*f[i]*f[j] ))
    b[o]=$(( a[i]*b[j] + b[i]*a[j] - 2*e[i]*f[j] - 2*f[i]*e[j] ))
    e[o]=$(( a[i]*e[j] + 2*b[i]*b[j] + e[i]*a[j] + 8*b[i]*f[j] + 4*e[i]*e[j] + 8*f[i]*b[j] + 28*f[i]*f[j] ))
    f[o]=$(( a[i]*f[j] + b[i]*e[j] + e[i]*b[j] + f[i]*a[j] + 4*e[i]*f[j] + 4*f[i]*e[j] ))
}
 
function conjugate
{
    typeset o=$1
    typeset i=$2
 
    a[o]=$(( a[i] + 4*e[i] ))
    b[o]=$(( 3*b[i] + 10*f[i] ))
    e[o]=$(( -e[i] ))
    f[o]=$(( -b[i] - 3*f[i] ))
}
 
function parse_args
{
    for arg
    do
                variable=${arg%=*}
                n=${variable##[a-zA-Z]}
                a[n]=0
                b[n]=0
                e[n]=0
                f[n]=0
    done
 
    for arg
    do
                variable=${arg%=*}
                n=${variable##[abef]}
                base=${variable%%[0-9]}
                value=${arg#*=}
                eval $base\[$n\]=\$value
    done
}
 
function display
{
    typeset o=$1
    printf "a[%s]=%s\n" $o ${a[o]}
    printf "b[%s]=%s\n" $o ${b[o]}
    printf "e[%s]=%s\n" $o ${e[o]}
    printf "f[%s]=%s\n" $o ${f[o]}
}
 
main $*
